Public Class LBExtraWertAngabeNumerischOberUntergrenze
    Inherits LBExtraWertAngabe

    Private m_Obergrenze As Decimal = 0D
    Property Obergrenze() As Decimal
        Get
            Return m_Obergrenze
        End Get
        Set(ByVal value As Decimal)
            m_Obergrenze = value
        End Set
    End Property
    Private m_Untergrenze As Decimal = 0D
    Property Untergrenze() As Decimal
        Get
            Return m_Untergrenze
        End Get
        Set(ByVal value As Decimal)
            m_Untergrenze = value
        End Set
    End Property

    Public Overrides ReadOnly Property Typ() As LaborBasisWertTypen
        Get
            Return LaborBasisWertTypen.NumerischOberUntergrenze
        End Get
    End Property


    Public Overrides Sub Read_XML(ByVal Nd As System.Xml.XmlNode)
        m_Obergrenze = CDec(Nd.Attributes("Obergrenze").Value)
        m_Untergrenze = CDec(Nd.Attributes("Untergrenze").Value)
    End Sub
    Public Overrides Sub Write_XML(ByVal Writer As System.Xml.XmlTextWriter)
        Writer.WriteAttributeString("Obergrenze", m_Obergrenze.ToString)
        Writer.WriteAttributeString("Untergrenze", m_Untergrenze.ToString)
    End Sub

    Public Overrides Function ToPersistString() As String
        Return m_Obergrenze.ToString & m_Untergrenze.ToString
    End Function

    Public Overrides Function CheckValue(ByVal Value As String) As AuswerteResultat
        Try
            Dim Wert As Decimal = CDec(Value)
            If Wert <= m_Obergrenze Then
                If Wert >= m_Untergrenze Then
                    Return AuswerteResultat.Normal
                Else
                    Return AuswerteResultat.ZuTief
                End If
            Else
                Return AuswerteResultat.ZuHoch
            End If
        Catch ex As Exception
            Return AuswerteResultat.Fehler
        End Try
    End Function

    Public Overrides Function GetZufallsWert() As String
        Dim Result As Decimal = CDec((m_Obergrenze * 1.5D - m_Untergrenze * 1.5D + 1D) * Rnd() + m_Untergrenze * 1.5D)
        Result = Math.Round(Result, 1)
        Return Result.ToString
    End Function
End Class
