Public Class LBExtraWertAngabeNumerischObergrenze
    Inherits LBExtraWertAngabe
    Private m_Obergrenze As Decimal = 0D
    Property Obergrenze() As Decimal
        Get
            Return m_Obergrenze
        End Get
        Set(ByVal value As Decimal)
            m_Obergrenze = value
        End Set
    End Property
    Public Overrides ReadOnly Property Typ() As LaborBasisWertTypen
        Get
            Return LaborBasisWertTypen.NumerischObergrenze
        End Get
    End Property

    Public Overrides Sub Read_XML(ByVal Nd As System.Xml.XmlNode)
        m_Obergrenze = CDec(Nd.Attributes("Obergrenze").Value)
    End Sub
    Public Overrides Sub Write_XML(ByVal Writer As System.Xml.XmlTextWriter)
        Writer.WriteAttributeString("Obergrenze", m_Obergrenze.ToString)
    End Sub

    Public Overrides Function ToPersistString() As String
        Return m_Obergrenze.ToString
    End Function

    Public Overrides Function CheckValue(ByVal Value As String) As AuswerteResultat
        Try
            Dim Wert As Decimal = CDec(Value)
            If Wert <= m_Obergrenze Then
                Return AuswerteResultat.Normal
            Else
                Return AuswerteResultat.ZuHoch
            End If
        Catch ex As Exception
            Return AuswerteResultat.Fehler
        End Try
    End Function
    Public Overrides Function GetZufallsWert() As String
        Dim Result As Decimal = ((m_Obergrenze / 2D) * 1.5D + 1D) * Rnd()
        Result = Math.Round(Result, 1)
        Return Result.ToString
    End Function
End Class
