Imports System.Xml
Public Class LaborBasisDatensammlung
    Public Event Einheiten_Geaendert()

    Private WithEvents m_Einheiten As New List(Of LaborBasisWertEinheit)
    Private WithEvents m_Gruppen As New List(Of LaborBasisWertgruppe)
    Private m_Werte As New List(Of LaborBasisWert)
    Private m_LeerEinheit As LaborBasisWertEinheit
    Private m_Pfad As String = ""
    Property Pfad() As String
        Get
            Return m_Pfad
        End Get
        Set(ByVal value As String)
            m_Pfad = value
        End Set
    End Property

    ReadOnly Property LeerEinheit() As LaborBasisWertEinheit
        Get
            Return m_LeerEinheit
        End Get
    End Property

    ReadOnly Property Einheiten() As List(Of LaborBasisWertEinheit)
        Get
            Return m_Einheiten
        End Get
    End Property
    ReadOnly Property Gruppen() As List(Of LaborBasisWertgruppe)
        Get
            Return m_Gruppen
        End Get
    End Property
    ReadOnly Property Werte() As List(Of LaborBasisWert)
        Get
            Return m_Werte
        End Get
    End Property

    Public Sub New()
        'mmol/l
        m_LeerEinheit = New LaborBasisWertEinheit("-", "")
        m_Einheiten.Add(m_LeerEinheit)
        m_Einheiten.Add(New LaborBasisWertEinheit("mmol/l", "Millimol pro Liter"))
    End Sub
    Public Sub New(ByVal Pfad As String)
        Dim Nd As XmlNode = Me.GetXML(Pfad)
        m_Pfad = Pfad
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Einheiten" Then
                For Each yNd As XmlNode In xNd.ChildNodes
                    If yNd.Name = "Einheit" Then
                        m_Einheiten.Add(New LaborBasisWertEinheit(yNd))
                    ElseIf yNd.Name = "LeerEinheit" Then
                        m_LeerEinheit = New LaborBasisWertEinheit(yNd)
                        m_Einheiten.Add(m_LeerEinheit)
                    End If
                Next
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Gruppen" Then
                For Each yNd As XmlNode In xNd.ChildNodes
                    If yNd.Name = "Gruppe" Then
                        m_Gruppen.Add(New LaborBasisWertgruppe(yNd))
                    End If
                Next
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Werte" Then
                For Each yNd As XmlNode In xNd.ChildNodes
                    If yNd.Name = "Wert" Then
                        m_Werte.Add(New LaborBasisWert(yNd, m_Gruppen, m_Einheiten))
                    End If
                Next
                Exit For
            End If
        Next

    End Sub
    Public Sub RaiseEinheiten_Geaendert()
        RaiseEvent Einheiten_Geaendert()
    End Sub


    Public Overridable Sub Speichern()
        Dim Writer As XmlTextWriter = Me.GetWriter(m_Pfad)

        Writer.WriteStartElement("Einheiten")
        For Each Einh As LaborBasisWertEinheit In m_Einheiten
            If Einh Is m_LeerEinheit Then
                Writer.WriteStartElement("LeerEinheit")
            Else
                Writer.WriteStartElement("Einheit")
            End If
            Einh.Write_XML(Writer)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()
        Writer.WriteStartElement("Gruppen")
        For Each Gr As LaborBasisWertgruppe In m_Gruppen
            Writer.WriteStartElement("Gruppe")
            Gr.Write_XML(Writer)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()
        Writer.WriteStartElement("Werte")
        For Each wt As LaborBasisWert In m_Werte
            Writer.WriteStartElement("Wert")
            wt.Write_XML(Writer, m_Gruppen, m_Einheiten)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()

        Me.CloseWriter(Writer)
    End Sub

    Private Function GetWriter(ByVal Pfad As String) As XmlTextWriter
        Dim Writer As New XmlTextWriter(Pfad, System.Text.Encoding.UTF8)
        Writer.WriteStartDocument(True)

        Writer.WriteStartElement("Elemente")
        Writer.WriteStartElement("Content")
        Return Writer
    End Function
    Private Sub CloseWriter(ByVal Writer As XmlTextWriter)
        Writer.WriteEndElement()
        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
    End Sub

    Private Function GetXML(ByVal Pfad As String) As XmlNode
        Dim reader As XmlTextReader = New XmlTextReader(Pfad)

        reader.WhitespaceHandling = WhitespaceHandling.None
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(reader)
        reader.Close()

        Dim xnod As XmlNode = xmlDoc.DocumentElement

        Return xnod.ChildNodes(0)
    End Function
End Class
