Imports System.Xml
Public Class LaborBasisWert
    Private m_Kuerzel As String = "Neuer Laborwert"
    Private m_Langname As String = "Neuer Laborwert"
    Private m_Einheit As LaborBasisWertEinheit
    Private m_ExplizitEinzeln As Boolean = False
    Private m_Geschlecht As LaborBasisGruppenGeschlechter = LaborBasisGruppenGeschlechter.mnnlich
    Private m_Typ As LaborBasisWertTypen = LaborBasisWertTypen.NumerischOberUntergrenze
    Private m_Extra As LBExtraWertAngabe = New LBExtraWertAngabeNumerischOberUntergrenze
    Public Event Geaendert()
    Public Gruppen As New List(Of LaborBasisWertgruppe)
    ReadOnly Property Extra() As LBExtraWertAngabe
        Get
            Return m_Extra
        End Get
    End Property
    Property Kuerzel() As String
        Get
            Return m_Kuerzel
        End Get
        Set(ByVal value As String)
            If m_Kuerzel <> value.Trim Then
                m_Kuerzel = value.Trim
                RaiseEvent Geaendert()
            End If
        End Set
    End Property
    Property Langname() As String
        Get
            Return m_Langname
        End Get
        Set(ByVal value As String)
            If m_Langname <> value.Trim Then
                m_Langname = value.Trim
                RaiseEvent Geaendert()
            End If
        End Set
    End Property
    Property Einheit() As LaborBasisWertEinheit
        Get
            Return m_Einheit
        End Get
        Set(ByVal value As LaborBasisWertEinheit)
            m_Einheit = value
        End Set
    End Property
    Property Typ() As LaborBasisWertTypen
        Get
            Return m_Typ
        End Get
        Set(ByVal value As LaborBasisWertTypen)
            If m_Typ <> value Then
                m_Typ = value
                Select Case m_Typ
                    Case LaborBasisWertTypen.NumerischObergrenze
                        m_Extra = New LBExtraWertAngabeNumerischObergrenze
                    Case LaborBasisWertTypen.NumerischOberUntergrenze
                        m_Extra = New LBExtraWertAngabeNumerischOberUntergrenze
                End Select
            End If
        End Set
    End Property
    Property ExplizitEinzeln() As Boolean
        Get
            Return m_ExplizitEinzeln
        End Get
        Set(ByVal value As Boolean)
            If m_ExplizitEinzeln <> value Then
                m_ExplizitEinzeln = value
            End If
        End Set
    End Property
    Property Geschlecht() As LaborBasisGruppenGeschlechter
        Get
            Return m_Geschlecht
        End Get
        Set(ByVal value As LaborBasisGruppenGeschlechter)
            m_Geschlecht = value
        End Set
    End Property
    Public Sub New(ByVal Einheit As LaborBasisWertEinheit)
        m_Einheit = Einheit
    End Sub
    Public Sub New(ByVal Nd As XmlNode, ByVal AlleGruppen As List(Of LaborBasisWertgruppe), ByVal AlleEinheiten As List(Of LaborBasisWertEinheit))
        m_Kuerzel = Nd.Attributes("Kuerzel").Value
        m_Langname = Nd.Attributes("Langname").Value
        m_Einheit = AlleEinheiten(CInt(Nd.Attributes("Einheit").Value))
        m_ExplizitEinzeln = CBool(Nd.Attributes("ExplizitEinzeln").Value)
        m_Geschlecht = CType(CInt(Nd.Attributes("Geschlecht").Value), LaborBasisGruppenGeschlechter)

        Dim GrpStr As String = Nd.Attributes("Gruppen").Value
        Dim Indizes() As String = Split(GrpStr, ",")

        For Each Txt As String In Indizes
            If Txt <> "" Then
                Gruppen.Add(AlleGruppen(CInt(Txt)))
            End If
        Next

        Me.Typ = CType(CInt(Nd.Attributes("Typ").Value), LaborBasisWertTypen)
        m_Extra.Read_XML(Nd)
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter, ByVal AlleGruppen As List(Of LaborBasisWertgruppe), ByVal AlleEinheiten As List(Of LaborBasisWertEinheit))
        Writer.WriteAttributeString("Kuerzel", m_Kuerzel)
        Writer.WriteAttributeString("Langname", m_Langname)
        Writer.WriteAttributeString("Einheit", AlleEinheiten.IndexOf(m_Einheit).ToString)
        Writer.WriteAttributeString("ExplizitEinzeln", m_ExplizitEinzeln.ToString)
        Writer.WriteAttributeString("Geschlecht", CInt(m_Geschlecht).ToString)

        Dim Indizes As New List(Of String)
        For Each Gr As LaborBasisWertgruppe In Gruppen
            Indizes.Add(AlleGruppen.IndexOf(Gr))
        Next
        Dim GrpStr As String = Join(Indizes.ToArray, ",")
        Writer.WriteAttributeString("Gruppen", GrpStr)

        Writer.WriteAttributeString("Typ", CInt(m_Typ).ToString)
        m_Extra.Write_XML(Writer)
    End Sub
    Public Function ToPersistString(ByVal DS As LaborBasisDatensammlung) As String
        Return m_Kuerzel & m_Langname & CInt(m_Typ).ToString & m_ExplizitEinzeln.ToString & CInt(m_Geschlecht).ToString & m_Extra.ToPersistString() & DS.Einheiten.IndexOf(m_Einheit).ToString
    End Function
    Public Function CheckValue(ByVal Value As String) As AuswerteResultat
        If Value.Trim = "" Then
            Return AuswerteResultat.Leer
        End If
        Return m_Extra.CheckValue(Value)
    End Function
    Public Function GetZufallsWert() As String
        Return m_Extra.GetZufallsWert
    End Function
End Class
