Imports System.Xml
Public Class LaborDatenProvider
    Public Event Datensammlung_Geaendert()
    Private m_DS As LaborBasisDatensammlung
    Property DS() As LaborBasisDatensammlung
        Get
            Return m_DS
        End Get
        Set(ByVal value As LaborBasisDatensammlung)
            If m_DS IsNot value Then
                m_DS = value
                RaiseEvent Datensammlung_Geaendert()
            End If
        End Set
    End Property


    Public Sub Datei_Neu()
        If Not SpeichernErfolgreich() Then
            Exit Sub
        End If
        Dim NewDS As New LaborBasisDatensammlung
        Me.DS = NewDS
    End Sub
    Public Sub Datei_Oeffnen()
        If Not SpeichernErfolgreich() Then
            Exit Sub
        End If

        Dim Dlg As New OpenFileDialog
        Dlg.Filter = "LaborBasisEditor Dateien (*.labxml)|*.labxml"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True
        Dlg.Multiselect = False

        If Dlg.ShowDialog() = DialogResult.OK Then
            Me.DS = New LaborBasisDatensammlung(Dlg.FileName)
        End If

    End Sub
    Public Function Datei_Speichern() As Boolean
        If m_DS.Pfad = "" Then
            Return Datei_SpeichernUnter()
        Else
            m_DS.Speichern()
            Return True
        End If
    End Function
    Public Function Datei_SpeichernUnter() As Boolean
        Dim Dlg As New SaveFileDialog
        Dlg.Filter = "LaborBasisEditor Dateien (*.labxml)|*.labxml"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True
        Dlg.AddExtension = True
        Dlg.FileName = m_DS.Pfad
        Dlg.OverwritePrompt = True
        If Dlg.ShowDialog() = DialogResult.OK Then
            m_DS.Pfad = Dlg.FileName
            m_DS.Speichern()
            Return True
        Else
            Return False
        End If
    End Function
    Private Function SpeichernErfolgreich() As Boolean
        If m_DS.Geaendert Then
            If MessageBox.Show("nderungen speichern?", "LaborBasisEditor", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                If Not Datei_Speichern() Then Return False
            End If
        End If
        Return True
    End Function
    Public Function Datei_Beenden() As Boolean
        Return SpeichernErfolgreich()
    End Function

    Public Sub New()
        Dim AD As New Anwendungsdaten
        AD.Icon_Verknpfung_herstellen()

        If My.Application.CommandLineArgs.Count > 0 Then
            If My.Application.CommandLineArgs.Count > 1 Then
                If My.Application.CommandLineArgs(1).ToLower = "/open/" Then
                    Dim DI As New IO.DirectoryInfo(My.Application.CommandLineArgs(0))
                    m_DS = New LaborBasisDatensammlung(DI.FullName)
                End If
            End If
        End If
        If m_DS Is Nothing Then
            m_DS = New LaborBasisDatensammlung
        End If


    End Sub
End Class
