Public Class LaborwertEditor
    Private WithEvents m_DS As LaborBasisDatensammlung
    Private m_Init As Boolean = False
    Private m_Wert As LaborBasis.LaborBasisWert
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        For I As Integer = 0 To 1
            Me.ComboBoxTyp.Items.Add(CType(I, LaborBasis.LaborBasisWertTypen))
        Next
        For I As Integer = 0 To 3
            Me.ComboBoxGeschlecht.Items.Add(CType(I, LaborBasis.LaborBasisGruppenGeschlechter))
        Next
        ReadDS()
        ReadData()
    End Sub


    WriteOnly Property DS() As LaborBasisDatensammlung
        Set(ByVal value As LaborBasisDatensammlung)
            m_DS = value
            m_Wert = Nothing
            ReadDS()
            ReadData()
        End Set
    End Property

    WriteOnly Property Wert() As LaborBasis.LaborBasisWert
        Set(ByVal value As LaborBasis.LaborBasisWert)
            m_Wert = value
            ReadData()
        End Set
    End Property
    Private Sub ReadDS()
        m_Init = True
        Me.ComboBoxEinheit.Items.Clear()
        Me.ListViewLaborwertgruppen.Items.Clear()
        If m_DS Is Nothing Then
            Me.ComboBoxEinheit.Enabled = False
            Me.ListViewLaborwertgruppen.Enabled = False
        Else
            For Each einh As LaborBasis.LaborBasisWertEinheit In m_DS.Einheiten
                Me.ComboBoxEinheit.Items.Add(einh)
            Next
            For Each gr As LaborBasis.LaborBasisWertgruppe In m_DS.Gruppen
                Me.ListViewLaborwertgruppen.Items.Add(New LaborBasisWertgruppenLVI(gr))
            Next
            Me.ComboBoxEinheit.Enabled = True
            Me.ListViewLaborwertgruppen.Enabled = True
        End If
        m_Init = False
    End Sub

    Private Sub ReadData()
        m_Init = True
        If m_Wert Is Nothing Then
            Me.TextBoxKuerzel.Text = ""
            Me.TextBoxLangbezeichnung.Text = ""
            Me.TextBoxKuerzel.Enabled = False
            Me.TextBoxLangbezeichnung.Enabled = False
            Me.ComboBoxEinheit.SelectedIndex = -1
            Me.ComboBoxTyp.SelectedIndex = -1
            Me.ComboBoxGeschlecht.SelectedIndex = -1
            Me.ComboBoxEinheit.Enabled = False
            Me.ComboBoxTyp.Enabled = False
            Me.ComboBoxGeschlecht.Enabled = False
            Me.CheckBoxExplizitEinzeln.Checked = False
            Me.CheckBoxExplizitEinzeln.Enabled = False

            For Each Itm As LaborBasisWertgruppenLVI In Me.ListViewLaborwertgruppen.Items
                Itm.Checked = False
            Next
            Me.ListViewLaborwertgruppen.Enabled = False
            Me.PanelSpezielleEigenschaften.Controls.Clear()
        Else
            Me.TextBoxKuerzel.Text = m_Wert.Kuerzel
            Me.TextBoxLangbezeichnung.Text = m_Wert.Langname
            Me.TextBoxKuerzel.Enabled = True
            Me.TextBoxLangbezeichnung.Enabled = True
            ComboBoxEinheit.SelectedItem = m_Wert.Einheit
            Me.ComboBoxTyp.SelectedItem = m_Wert.Typ
            Me.ComboBoxGeschlecht.SelectedItem = m_Wert.Geschlecht
            Me.ComboBoxEinheit.Enabled = True
            Me.ComboBoxTyp.Enabled = True
            Me.ComboBoxGeschlecht.Enabled = True
            Me.CheckBoxExplizitEinzeln.Checked = m_Wert.ExplizitEinzeln
            Me.CheckBoxExplizitEinzeln.Enabled = True
            For Each Itm As LaborBasisWertgruppenLVI In Me.ListViewLaborwertgruppen.Items
                Itm.Checked = m_Wert.Gruppen.Contains(Itm.Gruppe)
            Next
            Me.ListViewLaborwertgruppen.Enabled = True
            Me.PanelSpezielleEigenschaften.Controls.Clear()
            Dim Ctl As Control = Anwendungsdaten.GetControl(m_Wert.Extra)
            Ctl.Dock = DockStyle.Fill
            Me.PanelSpezielleEigenschaften.Controls.Add(Ctl)
        End If
        m_Init = False
    End Sub



    Private Sub TextBoxKuerzel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxKuerzel.TextChanged
        If m_Init Then Exit Sub
        m_Wert.Kuerzel = TextBoxKuerzel.Text
    End Sub

    Private Sub TextBoxLangbezeichnung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxLangbezeichnung.TextChanged
        If m_Init Then Exit Sub
        m_Wert.Langname = TextBoxLangbezeichnung.Text
    End Sub

    Private Sub ComboBoxEinheit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxEinheit.SelectedIndexChanged
        If m_Init Then Exit Sub
        m_Wert.Einheit = ComboBoxEinheit.SelectedItem
    End Sub

    Private Sub ComboBoxTyp_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTyp.SelectedIndexChanged
        If m_Init Then Exit Sub
        m_Wert.Typ = ComboBoxTyp.SelectedItem
        Me.PanelSpezielleEigenschaften.Controls.Clear()
        Dim Ctl As Control = Anwendungsdaten.GetControl(m_Wert.Extra)
        Ctl.Dock = DockStyle.Fill
        Me.PanelSpezielleEigenschaften.Controls.Add(Ctl)
    End Sub

    Private Sub ListViewLaborwertgruppen_ItemChecked(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckedEventArgs) Handles ListViewLaborwertgruppen.ItemChecked
        If m_Init Then Exit Sub
        Dim LVI As LaborBasisWertgruppenLVI = e.Item
        If LVI.Checked Then
            If Not m_Wert.Gruppen.Contains(LVI.Gruppe) Then
                m_Wert.Gruppen.Add(LVI.Gruppe)
            End If
        Else
            If m_Wert.Gruppen.Contains(LVI.Gruppe) Then
                m_Wert.Gruppen.Remove(LVI.Gruppe)
            End If
        End If
    End Sub

    Private Sub ListViewLaborwertgruppen_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewLaborwertgruppen.Resize
        If ListViewLaborwertgruppen.Columns.Count > 0 Then
            ListViewLaborwertgruppen.Columns(0).Width = ListViewLaborwertgruppen.Width - 4
        End If
    End Sub
    Private m_Moving As Boolean = False
    Private Sub ListViewLaborwertgruppen_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewLaborwertgruppen.SelectedIndexChanged
        If m_Moving Then Exit Sub
        If ListViewLaborwertgruppen.SelectedItems.Count = 0 Then
            Me.LaborwertGruppenEditor1.Source = Nothing
            Me.CommandPanel1.DeleteEnabled = False
            Me.CommandPanel1.MoveDownEnabled = False
            Me.CommandPanel1.MoveUpEnabled = False
        Else
            Dim LVI As LaborBasisWertgruppenLVI = ListViewLaborwertgruppen.SelectedItems(0)
            Me.LaborwertGruppenEditor1.Source = LVI.Gruppe
            Me.CommandPanel1.DeleteEnabled = True
            If LVI.Index > 0 Then
                Me.CommandPanel1.MoveUpEnabled = True
            Else
                Me.CommandPanel1.MoveUpEnabled = False
            End If
            If LVI.Index < ListViewLaborwertgruppen.Items.Count - 1 Then
                Me.CommandPanel1.MoveDownEnabled = True
            Else
                Me.CommandPanel1.MoveDownEnabled = False
            End If
        End If
    End Sub
    Private Sub CommandPanelLaborwertgruppen_AddNew() Handles CommandPanel1.AddNew
        m_Init = True
        Dim LG As New LaborBasis.LaborBasisWertgruppe
        Dim LVI As New LaborBasisWertgruppenLVI(LG)
        Me.ListViewLaborwertgruppen.Items.Add(LVI)
        m_DS.Gruppen.Add(LG)
        LVI.Selected = True
        Me.ListViewLaborwertgruppen.EnsureVisible(LVI.Index)
        m_Init = False
    End Sub
    Private Sub CommandPanelLaborwertgruppen_Delete() Handles CommandPanel1.Delete
        Dim LVI As LaborBasisWertgruppenLVI = ListViewLaborwertgruppen.SelectedItems(0)
        Dim Idx As Integer = LVI.Index - 1

        Dim Gr As LaborBasis.LaborBasisWertgruppe = LVI.Gruppe
        Dim IstEnthalten As Boolean = False
        For Each Wt As LaborBasis.LaborBasisWert In m_DS.Werte
            If Wt.Gruppen.Contains(Gr) Then
                IstEnthalten = True
                Exit For
            End If
        Next
        If IstEnthalten Then
            If MessageBox.Show("Mindestens einem Laborwert ist diese Gruppe zugeordnet." & vbCrLf & "Trotzdem lschen?", "LaborBasisEditor", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.No Then Exit Sub
        End If
        If IstEnthalten Then
            For Each Wt As LaborBasis.LaborBasisWert In m_DS.Werte
                If Wt.Gruppen.Contains(Gr) Then
                    Wt.Gruppen.Remove(Gr)
                End If
            Next
        End If
        ListViewLaborwertgruppen.Items.Remove(LVI)
        m_DS.Gruppen.Remove(Gr)

        If Idx > -1 Then
            ListViewLaborwertgruppen.Items(Idx).Selected = True
        Else
            If ListViewLaborwertgruppen.Items.Count > 0 Then
                ListViewLaborwertgruppen.Items(0).Selected = True
            End If
        End If
    End Sub

    Private Sub m_DS_Einheiten_Geaendert() Handles m_DS.Einheiten_Geaendert
        m_Init = True
        Me.ComboBoxEinheit.Items.Clear()
        For Each einh As LaborBasis.LaborBasisWertEinheit In m_DS.Einheiten
            Me.ComboBoxEinheit.Items.Add(einh)
        Next
        If m_Wert IsNot Nothing Then
            Me.ComboBoxEinheit.SelectedItem = m_Wert.Einheit
        End If
        m_Init = False
    End Sub

    Private Sub ComboBoxGeschlecht_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxGeschlecht.SelectedIndexChanged
        If m_Init Then Exit Sub
        m_Wert.Geschlecht = ComboBoxGeschlecht.SelectedItem
    End Sub

    Private Sub CheckBoxExplizitEinzeln_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxExplizitEinzeln.CheckedChanged
        If m_Init Then Exit Sub
        m_Wert.ExplizitEinzeln = CheckBoxExplizitEinzeln.Checked
    End Sub
    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        m_Moving = True
        Dim LVI As LaborBasisWertgruppenLVI = ListViewLaborwertgruppen.SelectedItems(0)
        Dim Idx As Integer = LVI.Index
        Me.ListViewLaborwertgruppen.Items.Remove(LVI)
        m_DS.Gruppen.Remove(LVI.Gruppe)
        Me.ListViewLaborwertgruppen.Items.Insert(Idx + 1, LVI)
        m_DS.Gruppen.Insert(Idx + 1, LVI.Gruppe)
        LVI.Selected = True
        CheckUpDown()
        m_Moving = False
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp
        m_Moving = True
        Dim LVI As LaborBasisWertgruppenLVI = ListViewLaborwertgruppen.SelectedItems(0)
        Dim Idx As Integer = LVI.Index
        Me.ListViewLaborwertgruppen.Items.Remove(LVI)
        m_DS.Gruppen.Remove(LVI.Gruppe)
        Me.ListViewLaborwertgruppen.Items.Insert(Idx - 1, LVI)
        m_DS.Gruppen.Insert(Idx - 1, LVI.Gruppe)
        LVI.Selected = True
        CheckUpDown()
        m_Moving = False
    End Sub

    Private Sub CheckUpDown()
        Dim LVI As LaborBasisWertgruppenLVI = ListViewLaborwertgruppen.SelectedItems(0)
        If LVI.Index = 0 Then
            Me.CommandPanel1.MoveUpEnabled = False
        Else
            Me.CommandPanel1.MoveUpEnabled = True
        End If
        If LVI.Index = Me.ListViewLaborwertgruppen.Items.Count - 1 Then
            Me.CommandPanel1.MoveDownEnabled = False
        Else
            Me.CommandPanel1.MoveDownEnabled = True
        End If
    End Sub
End Class
