Public Class frm_Einheiten_Bearbeiten
    Private m_DS As LaborBasisDatensammlung

    Public Sub New(ByVal DS As LaborBasisDatensammlung)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_DS = DS
        Me.AcceptButton = Me.OkAbortPanel1.ButtonOK
        Me.OkAbortPanel1.ButtonAbbrechen.Visible = False
        ReadData()
    End Sub
    Private Sub ReadData()
        For Each Einh As LaborBasis.LaborBasisWertEinheit In m_DS.Einheiten
            Me.ListViewEinheiten.Items.Add(New LaborBasisEinheitLVI(Einh))
        Next

        If ListViewEinheiten.Items.Count > 0 Then
            ListViewEinheiten.Items(0).Selected = True
        End If
    End Sub

    Private Sub ListViewEinheiten_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewEinheiten.Resize
        If ListViewEinheiten.Columns.Count > 0 Then
            ListViewEinheiten.Columns(0).Width = ListViewEinheiten.Width - 4
        End If
    End Sub


    Private Sub ListViewEinheiten_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewEinheiten.SelectedIndexChanged
        If m_Moving Then Exit Sub
        If ListViewEinheiten.SelectedItems.Count = 0 Then
            SetSelected(Nothing)
        Else
            SetSelected(ListViewEinheiten.SelectedItems(0))
        End If
    End Sub
    Private m_Init As Boolean = False
    Private m_SelectedEinheit As LaborBasis.LaborBasisWertEinheit = Nothing
    Private Sub SetSelected(ByVal LVI As LaborBasisEinheitLVI)
        m_Init = True
        If LVI Is Nothing Then
            Me.TextBoxAusfhrlich.Text = ""
            Me.TextBoxAusfhrlich.Enabled = False
            Me.TextBoxEinheit.Text = ""
            Me.TextBoxEinheit.Enabled = False
            m_SelectedEinheit = Nothing
            Me.CommandPanel1.DeleteEnabled = False
            Me.CommandPanel1.MoveDownEnabled = False
            Me.CommandPanel1.MoveUpEnabled = False
        Else
            m_SelectedEinheit = LVI.Einheit
            Me.TextBoxAusfhrlich.Text = m_SelectedEinheit.LangWert
            Me.TextBoxAusfhrlich.Enabled = True
            Me.TextBoxEinheit.Text = m_SelectedEinheit.Kuerzel
            Me.TextBoxEinheit.Enabled = True
            Me.CommandPanel1.DeleteEnabled = True
            If m_SelectedEinheit Is m_DS.LeerEinheit Then
                Me.TextBoxAusfhrlich.Enabled = False
                Me.TextBoxEinheit.Enabled = False
                Me.CommandPanel1.DeleteEnabled = False
            End If
            If LVI.Index = 0 Then
                Me.CommandPanel1.MoveUpEnabled = False
            Else
                Me.CommandPanel1.MoveUpEnabled = True
            End If
            If LVI.Index = Me.ListViewEinheiten.Items.Count - 1 Then
                Me.CommandPanel1.MoveDownEnabled = False
            Else
                Me.CommandPanel1.MoveDownEnabled = True
            End If
        End If
        m_Init = False
    End Sub

    Private Sub TextBoxEinheit_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxEinheit.TextChanged
        If m_Init Then Exit Sub
        m_SelectedEinheit.Kuerzel = TextBoxEinheit.Text
    End Sub

    Private Sub TextBoxAusfhrlich_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxAusfhrlich.TextChanged
        If m_Init Then Exit Sub
        m_SelectedEinheit.LangWert = TextBoxAusfhrlich.Text
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew
        Dim NewEinheit As New LaborBasis.LaborBasisWertEinheit("Neue Laboreinheit", "Neue Laboreinheit")
        Dim LVI As New LaborBasisEinheitLVI(NewEinheit)
        m_DS.Einheiten.Add(NewEinheit)
        Me.ListViewEinheiten.Items.Add(LVI)
        ListViewEinheiten.EnsureVisible(LVI.Index)
        LVI.Selected = True
    End Sub

    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        Dim LVI As LaborBasisEinheitLVI = ListViewEinheiten.SelectedItems(0)
        Dim Idx As Integer = LVI.Index
        Dim einh As LaborBasis.LaborBasisWertEinheit = LVI.Einheit
        For Each Wt As LaborBasis.LaborBasisWert In m_DS.Werte
            If Wt.Einheit Is einh Then
                MessageBox.Show("Mindestens einem Laborwert ist diese Einheit zugeordnet." & vbCrLf & "So z.B.: " & Wt.Kuerzel & vbCrLf & "Darum kann diese Einheit nicht gelscht werden.", "LaborBasisEditor", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If
        Next

        m_DS.Einheiten.Remove(einh)
        Me.ListViewEinheiten.Items.Remove(LVI)
        If Idx > -1 Then
            ListViewEinheiten.Items(Idx).Selected = True
        Else
            If ListViewEinheiten.Items.Count > 0 Then
                ListViewEinheiten.Items(0).Selected = True
            End If
        End If
    End Sub
    Private m_Moving As Boolean = False
    Private Sub CommandPanel1_MoveDown() Handles CommandPanel1.MoveDown
        m_Moving = True
        Dim LVI As LaborBasisEinheitLVI = ListViewEinheiten.SelectedItems(0)
        Dim Idx As Integer = LVI.Index
        Me.ListViewEinheiten.Items.Remove(LVI)
        m_DS.Einheiten.Remove(LVI.Einheit)
        Me.ListViewEinheiten.Items.Insert(Idx + 1, LVI)
        m_DS.Einheiten.Insert(Idx + 1, LVI.Einheit)
        LVI.Selected = True
        CheckUpDown()
        m_Moving = False
    End Sub

    Private Sub CommandPanel1_MoveUp() Handles CommandPanel1.MoveUp
        m_Moving = True
        Dim LVI As LaborBasisEinheitLVI = ListViewEinheiten.SelectedItems(0)
        Dim Idx As Integer = LVI.Index
        Me.ListViewEinheiten.Items.Remove(LVI)
        m_DS.Einheiten.Remove(LVI.Einheit)
        Me.ListViewEinheiten.Items.Insert(Idx - 1, LVI)
        m_DS.Einheiten.Insert(Idx - 1, LVI.Einheit)
        LVI.Selected = True
        CheckUpDown()
        m_Moving = False
    End Sub

    Private Sub CheckUpDown()
        Dim LVI As LaborBasisEinheitLVI = ListViewEinheiten.SelectedItems(0)
        If LVI.Index = 0 Then
            Me.CommandPanel1.MoveUpEnabled = False
        Else
            Me.CommandPanel1.MoveUpEnabled = True
        End If
        If LVI.Index = Me.ListViewEinheiten.Items.Count - 1 Then
            Me.CommandPanel1.MoveDownEnabled = False
        Else
            Me.CommandPanel1.MoveDownEnabled = True
        End If
    End Sub
End Class