Public Class LaborGruppenAnzeiger
    Private m_Gruppe As LaboranzeigeGruppe
    Private m_WertControls As New List(Of LaborWertAnzeiger)
    
    Private m_ControlTop As Integer = 18
    Private m_SonstNormalAnzeiger As SonstNormalAnzeiger
    ReadOnly Property Gruppe() As LaboranzeigeGruppe
        Get
            Return m_Gruppe
        End Get
    End Property
    Public Sub New(ByVal Gruppe As LaboranzeigeGruppe)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Gruppe = Gruppe
        Me.ColorLabel1.Text = m_Gruppe.BasisGruppe.Name
       
        Me.SetStyle(ControlStyles.OptimizedDoubleBuffer Or ControlStyles.AllPaintingInWmPaint Or ControlStyles.Selectable, True)
    End Sub
    Public Sub Clear_Wert_Controls()
        For Each Ctl As Control In m_WertControls
            Me.Controls.Remove(Ctl)
            RemoveHandler Ctl.MouseDown, AddressOf WertAnzeiger_MouseDown
            RemoveHandler Ctl.MouseUp, AddressOf WertAnzeiger_MouseUp
            RemoveHandler Ctl.MouseMove, AddressOf WertAnzeiger_MouseMove
        Next
        m_WertControls.Clear()
        If m_SonstNormalAnzeiger IsNot Nothing Then
            Me.Controls.Remove(m_SonstNormalAnzeiger)
            m_SonstNormalAnzeiger = Nothing
        End If
    End Sub
    Public Sub RefreshControls(ByVal WertControls As Dictionary(Of LaborwertAnzeigeElement, LaborWertAnzeiger))
        Me.SuspendLayout()
        m_ControlTop = 18

        If Not m_Gruppe.BasisGruppe.ExplizitEinzeln AndAlso m_Gruppe.AnzeigeWerte.Count > 1 Then
            m_SonstNormalAnzeiger = New SonstNormalAnzeiger(m_Gruppe)
            m_SonstNormalAnzeiger.Width = Me.Width - 2
            m_SonstNormalAnzeiger.Location = New Point(1, m_ControlTop)
            Me.Controls.Add(m_SonstNormalAnzeiger)
            m_ControlTop += 1 + m_SonstNormalAnzeiger.Height
        End If


        For Each El As LaborwertAnzeigeElement In m_Gruppe.AnzeigeWerte
            m_WertControls.Add(WertControls(El))
        Next
        Dim TmpTop As Integer = m_ControlTop

        Dim TmpTab As Integer = 3

        For Each Ctl As Control In m_WertControls
            Ctl.SuspendLayout()
            Ctl.Width = Me.Width - 3
            Ctl.Location = New Point(1, TmpTop)
            Ctl.TabIndex = TmpTab
            Me.Controls.Add(Ctl)
            TmpTop += Ctl.Height + 1
            TmpTab += 1
            Ctl.ResumeLayout()
            AddHandler Ctl.MouseDown, AddressOf WertAnzeiger_MouseDown
            AddHandler Ctl.MouseUp, AddressOf WertAnzeiger_MouseUp
            AddHandler Ctl.MouseMove, AddressOf WertAnzeiger_MouseMove
        Next

        Me.Height = TmpTop + 1
        Me.ResumeLayout()
    End Sub
    Private Sub RefreshLayOut()
        Me.SuspendLayout()
        Dim TmpTop As Integer = m_ControlTop
        Dim TmpTab As Integer = 3
        For Each Ctl As Control In m_WertControls
            Ctl.SuspendLayout()
            Ctl.Location = New Point(1, TmpTop)
            Ctl.TabIndex = TmpTab
            TmpTop += Ctl.Height + 1
            TmpTab += 1
            Ctl.ResumeLayout()
        Next
        Me.ResumeLayout()
    End Sub
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        Dim Rect As New Rectangle(0, 0, Me.Width - 1, Me.Height - 1)
        ControlPaint.DrawVisualStyleBorder(e.Graphics, Rect)
    End Sub

    Private Sub ColorLabel1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ColorLabel1.MouseDown
        Me.OnMouseDown(e)
    End Sub

    Private Sub ColorLabel1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ColorLabel1.MouseMove
        Me.OnMouseMove(e)
    End Sub

    Private Sub ColorLabel1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ColorLabel1.MouseUp
        Me.OnMouseUp(e)
    End Sub

    Private m_MoveFlag As Boolean = False
    Private m_MovePoint As Point
    Private m_WasMoved As Boolean = False
    Private Sub WertAnzeiger_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        m_MoveFlag = True
        m_WasMoved = False
        m_MovePoint = New Point(e.Location)
        Dim Ctl As Control = sender
        Ctl.BringToFront()
    End Sub


    Private Sub WertAnzeiger_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        If Not m_MoveFlag Then Exit Sub
       
        Dim Ctl As Control = sender
        m_WasMoved = True
        Dim NewLeft As Integer = Ctl.Left + (e.X - m_MovePoint.X)
        Ctl.Top = Ctl.Top + (e.Y - m_MovePoint.Y)
    End Sub
    Private Sub WertAnzeiger_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        m_MoveFlag = False
        If m_WasMoved Then
            Dim SuchIndex As Integer = -1
            Dim SuchCtl As LaborWertAnzeiger = sender

            For Each Ctl As Control In m_WertControls
                If Ctl.Top > SuchCtl.Top Then
                    SuchIndex = m_WertControls.IndexOf(Ctl)
                    Exit For
                End If
            Next
            If SuchIndex = -1 Then
                SuchIndex = m_WertControls.Count
            End If
            If SuchIndex > m_WertControls.IndexOf(SuchCtl) Then
                SuchIndex -= 1
            End If
            If SuchIndex > m_WertControls.Count - 1 Then
                SuchIndex = m_WertControls.Count - 1
            End If
            If SuchIndex = m_WertControls.IndexOf(SuchCtl) Then
                RefreshLayOut()
            Else
                m_Gruppe.MoveWertToIndex(SuchCtl.Element, SuchIndex)
                m_WertControls.Sort(New LaborWertAnzeigerComparer(m_Gruppe.AnzeigeWerte))
                RefreshLayOut()
            End If

        End If
    End Sub

    Private Sub LaborGruppenAnzeiger_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        Me.ColorLabel1.BackColor = Color.DarkBlue
    End Sub

    Private Sub LaborGruppenAnzeiger_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Leave
        Me.ColorLabel1.BackColor = Color.RoyalBlue
    End Sub
End Class
