Public Class LaborPanel
    Inherits Panel
    Private WithEvents m_BaseSammlung As LaborAnzeigeSammlung
    Private m_WertControls As New Dictionary(Of LaborwertAnzeigeElement, LaborWertAnzeiger)
    Private m_GroupControls As New List(Of LaborGruppenAnzeiger)
    Public Event Text_Changed()
    Public ReadOnly Property LaborText() As String
        Get
            If m_BaseSammlung Is Nothing Then
                Return ""
            Else
                Return m_BaseSammlung.Text
            End If
        End Get
    End Property
    Public Sub New()
        Me.AutoScroll = True
        Me.SetStyle(ControlStyles.DoubleBuffer _
   Or ControlStyles.UserPaint _
   Or ControlStyles.AllPaintingInWmPaint, _
   True)
    End Sub
    WriteOnly Property BaseSammlung() As LaborAnzeigeSammlung
        Set(ByVal value As LaborAnzeigeSammlung)
            m_BaseSammlung = value
            Fill()
        End Set
    End Property
    Private Sub Fill()
        m_WertControls.Clear()
        For Each Ctl As LaborGruppenAnzeiger In m_GroupControls
            RemoveHandler Ctl.MouseDown, AddressOf GruppenAnzeiger_MouseDown
            RemoveHandler Ctl.MouseUp, AddressOf GruppenAnzeiger_MouseUp
            RemoveHandler Ctl.MouseMove, AddressOf GruppenAnzeiger_MouseMove
        Next
        m_GroupControls.Clear()

        Me.Controls.Clear()
        If m_BaseSammlung IsNot Nothing Then
            For Each El As LaborwertAnzeigeElement In m_BaseSammlung.Elemente
                m_WertControls.Add(El, New LaborWertAnzeiger(El))
            Next
            For Each Grp As LaboranzeigeGruppe In m_BaseSammlung.Gruppen
                m_GroupControls.Add(New LaborGruppenAnzeiger(Grp))
            Next

            For Each Ctl As LaborGruppenAnzeiger In m_GroupControls
                AddHandler Ctl.MouseDown, AddressOf GruppenAnzeiger_MouseDown
                AddHandler Ctl.MouseUp, AddressOf GruppenAnzeiger_MouseUp
                AddHandler Ctl.MouseMove, AddressOf GruppenAnzeiger_MouseMove
                Ctl.Visible = False
                Ctl.RefreshControls(m_WertControls)
                Me.Controls.Add(Ctl)
            Next

            LayOutForGroupControls()
        End If
    End Sub
    Private Sub LayOutForGroupControls()
        Me.SuspendLayout()

        For Each Ctl As Control In m_GroupControls
            Ctl.SuspendLayout()
        Next

        Dim Spalten As Integer = 1
        Dim FirstControl As LaborGruppenAnzeiger = m_GroupControls(0)
        Dim SpaltenBreite As Integer = FirstControl.Width + 20
        If Me.Width > FirstControl.Width + 40 Then
            Dim Restbreite As Integer = Me.Width - 20
            Spalten = Restbreite \ SpaltenBreite
        End If

        Dim Idx As Integer = 0

        Dim TmpZeile As Integer = -1
        Dim AcZeilenHoehe As Integer = 0
        Dim TmpTop As Integer = 0
        For Each Ctl As Control In m_GroupControls
            Dim Zeile As Integer = (Idx + Spalten) \ Spalten - 1
            Dim Spalte As Integer = Idx - (Zeile * Spalten)

            If TmpZeile <> Zeile Then
                TmpZeile = Zeile
                TmpTop += AcZeilenHoehe + 20
                AcZeilenHoehe = 0
            End If

            Ctl.Location = New Point(Spalte * SpaltenBreite + 20, TmpTop)

            If AcZeilenHoehe < Ctl.Height Then
                AcZeilenHoehe = Ctl.Height
            End If

            Idx += 1
        Next
        For Each Ctl As Control In m_GroupControls
            Ctl.ResumeLayout(False)
            Ctl.Visible = True
        Next
        Me.ResumeLayout(False)
        Me.AutoScrollMinSize = New Size(SpaltenBreite * Spalten, m_GroupControls(m_GroupControls.Count - 1).Bottom + 20)
        'Me.Height = m_GroupControls(m_GroupControls.Count - 1).Bottom + 20

    End Sub

    Private Sub LaborPanel_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If m_GroupControls.Count > 0 Then LayOutForGroupControls()
    End Sub


    Private m_MoveFlag As Boolean = False
    Private m_MovePoint As Point
    Private m_WasMoved As Boolean = False
    Private Sub GruppenAnzeiger_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        m_MoveFlag = True
        m_WasMoved = False
        m_MovePoint = New Point(e.Location)
        Dim Ctl As Control = sender
        Ctl.BringToFront()
    End Sub
    Private Sub GruppenAnzeiger_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        If Not m_MoveFlag Then Exit Sub
        Dim Ctl As Control = sender
        m_WasMoved = True

        Dim NewLeft As Integer = Ctl.Left + (e.X - m_MovePoint.X)
        Dim NewRight As Integer = NewLeft + Ctl.Width

        If NewRight < AutoScrollMinSize.Width + 20 Then
            Ctl.Left = Ctl.Left + (e.X - m_MovePoint.X)
        End If

        Ctl.Top = Ctl.Top + (e.Y - m_MovePoint.Y)
        Me.Refresh()
    End Sub
    Private Sub GruppenAnzeiger_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        m_MoveFlag = False
        If m_WasMoved Then
            ReOrder_Controls(sender)
        End If
    End Sub
    Private Sub ReOrder_Controls(ByVal MovedControl As LaborGruppenAnzeiger)

        Dim Spalten As Integer = 1
        Dim FirstControl As LaborGruppenAnzeiger = m_GroupControls(0)
        Dim SpaltenBreite As Integer = FirstControl.Width + 20
        If Me.Width > FirstControl.Width + 40 Then
            Dim Restbreite As Integer = Me.Width - 20
            Spalten = Restbreite \ SpaltenBreite
        End If

        Dim ZielSpaltenIndex As Integer = -1
        Dim ZielZeilenIndex As Integer = -1
        For I As Integer = 0 To Spalten - 1
            If MovedControl.Left < 20 + SpaltenBreite * I Then
                ZielSpaltenIndex = I
                Exit For
            End If
        Next
        If ZielSpaltenIndex = -1 Then
            ZielSpaltenIndex = Spalten
        End If


        Dim AnzahlZeilen As Integer = (m_GroupControls.Count - 1 + Spalten) \ Spalten
        Dim ZeilenHeights(AnzahlZeilen - 1) As Integer

        For I As Integer = 0 To AnzahlZeilen - 1
            ZeilenHeights(I) = 0
        Next

        Dim Idx As Integer = 0

        Dim TmpZeile As Integer = -1
        Dim AcZeilenHoehe As Integer = 0
        Dim TmpTop As Integer = 0
        For Each Ctl As Control In m_GroupControls
            Dim Zeile As Integer = (Idx + Spalten) \ Spalten - 1

            If ZeilenHeights(Zeile) < Ctl.Height Then
                ZeilenHeights(Zeile) = Ctl.Height
            End If

            Idx += 1
        Next

        Dim ZeilenBottoms(AnzahlZeilen - 1) As Integer
        Dim TmpBottom As Integer = 0
        For I As Integer = 0 To AnzahlZeilen - 1
            TmpBottom += ZeilenHeights(I) + 20
            ZeilenBottoms(I) = TmpBottom
        Next
        For I As Integer = 0 To AnzahlZeilen - 1
            If MovedControl.Top + Me.AutoScrollPosition.Y < ZeilenBottoms(I) Then
                ZielZeilenIndex = I
                Exit For
            End If
        Next

        If ZielZeilenIndex = -1 Then
            ZielZeilenIndex = AnzahlZeilen - 1
        End If

        Dim ZielControlIndex As Integer = ZielZeilenIndex * Spalten + ZielSpaltenIndex
        If ZielControlIndex > m_GroupControls.IndexOf(MovedControl) Then
            ZielControlIndex -= 1
        End If
        If ZielControlIndex > m_GroupControls.Count - 1 Then
            ZielControlIndex = m_GroupControls.Count - 1
        End If

        If ZielControlIndex = m_GroupControls.IndexOf(MovedControl) Then
            LayOutForGroupControls()
        Else
            m_BaseSammlung.MoveGroupToIndex(MovedControl.Gruppe, ZielControlIndex)
            For Each Ctl As LaborGruppenAnzeiger In m_GroupControls
                Ctl.Clear_Wert_Controls()
            Next
            For Each Ctl As LaborGruppenAnzeiger In m_GroupControls
                Ctl.Clear_Wert_Controls()
            Next
            For Each Ctl As LaborGruppenAnzeiger In m_GroupControls
                Ctl.RefreshControls(m_WertControls)
            Next
            m_GroupControls.Sort(New LaborGruppenComparer(m_BaseSammlung.Gruppen))
            LayOutForGroupControls()
        End If


        'Invalidate()
        ''MsgBox(ZielControlIndex)
        ''m_BaseSammlung
    End Sub

    'Private m_ZielIndex As Integer
    'Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
    '    MyBase.OnPaint(e)
    '    e.Graphics.DrawString(m_ZielIndex.ToString, Me.Font, Brushes.Black, 0, 0)
    'End Sub

    Private Sub m_BaseSammlung_TextChanged() Handles m_BaseSammlung.TextChanged
        RaiseEvent Text_Changed()
    End Sub
End Class
