Imports System.Xml
Public Class LaborAnzeigeSammlung
    Private m_Basis As LaborBasis.LaborBasisDatensammlung
    Private m_Gruppen As New List(Of LaboranzeigeGruppe)
    Private m_Elemente As New List(Of LaborwertAnzeigeElement)

    Private m_Text As String = ""
    Public Event TextChanged()

    ReadOnly Property Text() As String
        Get
            Return m_Text
        End Get
    End Property
    ReadOnly Property Elemente() As List(Of LaborwertAnzeigeElement)
        Get
            Return m_Elemente
        End Get
    End Property
    ReadOnly Property Gruppen() As List(Of LaboranzeigeGruppe)
        Get
            Return m_Gruppen
        End Get
    End Property
    Public Sub CreateExample()
        For Each El As LaborwertAnzeigeElement In m_Elemente
            El.Text = El.BasisWert.GetZufallsWert
        Next
        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            Grp.SonstNormalAuswahl = True
        Next
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        Dim Sammlg As New LabSpeicherSammlung(Nd)
        m_Basis = DataProvider.LaborBasis

        Dim xTmpGruppen As New Dictionary(Of String, LaborBasis.LaborBasisWertgruppe)
        For Each Grp As LaborBasis.LaborBasisWertgruppe In m_Basis.Gruppen
            xTmpGruppen.Add(Grp.Name, Grp)
        Next
        Dim xTmpElemente As New Dictionary(Of String, LaborBasis.LaborBasisWert)
        For Each El As LaborBasis.LaborBasisWert In m_Basis.Werte
            xTmpElemente.Add(El.Kuerzel, El)
        Next


        Dim ElementsWithError As New List(Of LabSpeicherElement)
        Dim VorhandeneGruppen As New List(Of LaborBasis.LaborBasisWertgruppe)
        Dim VorhandeneElemente As New List(Of LaborBasis.LaborBasisWert)

        For Each Grp As LabSpeicherGruppe In Sammlg
            If xTmpGruppen.ContainsKey(Grp.Kuerzel) Then
                Dim NewGroup As New LaboranzeigeGruppe(xTmpGruppen(Grp.Kuerzel), Me)
                m_Gruppen.Add(NewGroup)
                VorhandeneGruppen.Add(xTmpGruppen(Grp.Kuerzel))
                For Each el As LabSpeicherElement In Grp
                    If xTmpElemente.ContainsKey(el.Kuerzel) Then
                        Dim NewElement As New LaborwertAnzeigeElement(xTmpElemente(el.Kuerzel))
                        NewElement.Text = el.Text
                        m_Elemente.Add(NewElement)
                        NewGroup.AnzeigeWerte.Add(NewElement)
                        VorhandeneElemente.Add(xTmpElemente(el.Kuerzel))
                    Else
                        ElementsWithError.Add(el)
                    End If
                Next
            Else
                For Each el As LabSpeicherElement In Grp
                    ElementsWithError.Add(el)
                Next
            End If
        Next

        For Each Grp As LaborBasis.LaborBasisWertgruppe In m_Basis.Gruppen
            If Not VorhandeneGruppen.Contains(Grp) Then
                m_Gruppen.Add(New LaboranzeigeGruppe(Grp, Me))
            End If
        Next

        Dim TmpGruppen As New Dictionary(Of LaborBasis.LaborBasisWertgruppe, LaboranzeigeGruppe)
        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            TmpGruppen.Add(Grp.BasisGruppe, Grp)
        Next

        For Each Wt As LaborBasis.LaborBasisWert In m_Basis.Werte
            If Not VorhandeneElemente.Contains(Wt) Then
                Dim El As New LaborwertAnzeigeElement(Wt)
                m_Elemente.Add(El)
                If Wt.Gruppen.Count > 0 Then
                    TmpGruppen(Wt.Gruppen(0)).AnzeigeWerte.Add(El)
                End If
            End If
        Next

        Dim TmpElemente As New Dictionary(Of String, LaborwertAnzeigeElement)
        For Each el As LaborwertAnzeigeElement In m_Elemente
            TmpElemente.Add(el.BasisWert.Kuerzel, el)
        Next


        For Each el As LabSpeicherElement In ElementsWithError
            If TmpElemente.ContainsKey(el.Kuerzel) Then
                TmpElemente(el.Kuerzel).Text = el.Text
            End If
        Next
        For Each el As LaborwertAnzeigeElement In m_Elemente
            AddHandler el.TextChanged, AddressOf RefreshText
        Next
        m_Text = CreateText()
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Dim Sammlg As New LabSpeicherSammlung
        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            Dim SGrp As New LabSpeicherGruppe(Grp.BasisGruppe.Name)
            Sammlg.Add(SGrp)
            For Each el As LaborwertAnzeigeElement In Grp.AnzeigeWerte
                Dim SEl As New LabSpeicherElement(el.Text, el.BasisWert.Kuerzel)
                SGrp.Add(SEl)
            Next
        Next
        Sammlg.Write_XML(Writer)
    End Sub
    Public Sub New()
        m_Basis = DataProvider.LaborBasis
        First_Gruppen_Erstellen()
    End Sub
    Private Sub First_Gruppen_Erstellen()
        'Damit wird die erste Ansicht der Anzeigegrupen erstellt
        For Each Grp As LaborBasis.LaborBasisWertgruppe In m_Basis.Gruppen
            m_Gruppen.Add(New LaboranzeigeGruppe(Grp, Me))
        Next
        Dim TmpGruppen As New Dictionary(Of LaborBasis.LaborBasisWertgruppe, LaboranzeigeGruppe)
        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            TmpGruppen.Add(Grp.BasisGruppe, Grp)
        Next

        For Each Wt As LaborBasis.LaborBasisWert In m_Basis.Werte
            Dim El As New LaborwertAnzeigeElement(Wt)
            AddHandler El.TextChanged, AddressOf RefreshText
            m_Elemente.Add(El)
            If Wt.Gruppen.Count > 0 Then
                TmpGruppen(Wt.Gruppen(0)).AnzeigeWerte.Add(El)
            End If
        Next
        m_Text = CreateText()
    End Sub

    Public Sub MoveGroupToIndex(ByVal AGrp As LaboranzeigeGruppe, ByVal NewIndex As Integer)
        If NewIndex = m_Gruppen.IndexOf(AGrp) Then Exit Sub
        m_Gruppen.Remove(AGrp)
        m_Gruppen.Insert(NewIndex, AGrp)

        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            Grp.AnzeigeWerte.Clear()
        Next

        Dim TmpElemente As New List(Of LaborwertAnzeigeElement)
        TmpElemente.AddRange(m_Elemente.ToArray)
        TmpElemente.Reverse()

        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            For I As Integer = TmpElemente.Count - 1 To 0 Step -1
                If TmpElemente(I).BasisWert.Gruppen.Contains(Grp.BasisGruppe) Then
                    Grp.AnzeigeWerte.Add(TmpElemente(I))
                    TmpElemente.RemoveAt(I)
                End If
            Next
        Next
        RefreshText()
    End Sub

    Public Sub OnContentChange()
        RefreshText()
    End Sub


    Private Function CreateText() As String
        Dim Pathologische As New List(Of GenderText)
        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            For Each El As LaborwertAnzeigeElement In Grp.AnzeigeWerte
                If El.Result = LaborBasis.AuswerteResultat.ZuHoch OrElse El.Result = LaborBasis.AuswerteResultat.ZuTief Then
                    Pathologische.Add(New GenderText(El.BasisWert.Langname & " " & El.Text, El.BasisWert.Geschlecht))
                End If
            Next
        Next

        Dim NormalWerte As New List(Of GenderText)

        For Each Grp As LaboranzeigeGruppe In m_Gruppen
            If Grp.BasisGruppe.ExplizitEinzeln Then
                For Each El As LaborwertAnzeigeElement In Grp.AnzeigeWerte
                    If El.Result = LaborBasis.AuswerteResultat.Normal Then
                        NormalWerte.Add(New GenderText(El.BasisWert.Langname, El.BasisWert.Geschlecht))
                    End If
                Next
            Else
                Dim ExplizitNormale As New List(Of LaborwertAnzeigeElement)
                Dim AndereNormale As New List(Of LaborwertAnzeigeElement)
                Dim Pathologisch As New List(Of LaborwertAnzeigeElement)

                For Each El As LaborwertAnzeigeElement In Grp.AnzeigeWerte
                    If El.Result = LaborBasis.AuswerteResultat.ZuHoch OrElse El.Result = LaborBasis.AuswerteResultat.ZuTief Then
                        Pathologisch.Add(El)
                    ElseIf El.Result = LaborBasis.AuswerteResultat.Normal Then
                        If El.BasisWert.ExplizitEinzeln Then
                            ExplizitNormale.Add(El)
                        Else
                            AndereNormale.Add(El)
                        End If
                    ElseIf El.Result = LaborBasis.AuswerteResultat.Leer AndAlso Grp.SonstNormalAuswahl Then
                        If El.BasisWert.ExplizitEinzeln Then
                            ExplizitNormale.Add(El)
                        Else
                            AndereNormale.Add(El)
                        End If
                    End If
                Next

                If AndereNormale.Count > 0 Then
                    Dim ZWort As String = ""
                    If Pathologisch.Count > 0 Then
                        Select Case Grp.BasisGruppe.Geschlecht
                            Case LaborBasis.LaborBasisGruppenGeschlechter.mnnlich
                                ZWort = "weiterer "
                            Case LaborBasis.LaborBasisGruppenGeschlechter.weiblich
                                ZWort = "weitere "
                            Case LaborBasis.LaborBasisGruppenGeschlechter.schlich
                                ZWort = "weiteres "
                            Case LaborBasis.LaborBasisGruppenGeschlechter.Mehrzahl
                                ZWort = "weitere "
                        End Select
                    End If
                    NormalWerte.Add(New GenderText(ZWort & Grp.BasisGruppe.Name, Grp.BasisGruppe.Geschlecht))
                End If
                If ExplizitNormale.Count > 0 Then
                    For Each El As LaborwertAnzeigeElement In ExplizitNormale
                        NormalWerte.Add(New GenderText(El.BasisWert.Langname, El.BasisWert.Geschlecht))
                    Next
                End If
            End If
        Next

        Dim PathologischText As String = JoinText(Pathologische)
        Dim NormalText As String = JoinText(NormalWerte)
        Dim Txt As String = ""
        If Pathologische.Count > 1 Then
            Txt = "Pathologisch waren " & PathologischText & "."
        ElseIf Pathologische.Count = 1 Then
            Dim Vorwort As String = ""
            Select Case Pathologische(0).Gender
                Case LaborBasis.LaborBasisGruppenGeschlechter.mnnlich
                    Vorwort = "Pathologischer "
                Case LaborBasis.LaborBasisGruppenGeschlechter.weiblich
                    Vorwort = "Pathologische "
                Case LaborBasis.LaborBasisGruppenGeschlechter.schlich
                    Vorwort = "Pathologisches "
                Case LaborBasis.LaborBasisGruppenGeschlechter.Mehrzahl
                    Vorwort = "Pathologische "
            End Select
            Txt = Vorwort & PathologischText & "."
        Else
            Txt = "Keine pathologischen Werte."
        End If
        If NormalWerte.Count = 1 Then
            Dim Vorwort As String = ""
            Select Case NormalWerte(0).Gender
                Case LaborBasis.LaborBasisGruppenGeschlechter.mnnlich
                    Vorwort = "Normaler "
                Case LaborBasis.LaborBasisGruppenGeschlechter.weiblich
                    Vorwort = "Normale "
                Case LaborBasis.LaborBasisGruppenGeschlechter.schlich
                    Vorwort = "Normales "
                Case LaborBasis.LaborBasisGruppenGeschlechter.Mehrzahl
                    Vorwort = "Normale "
            End Select
            Txt &= " " & Vorwort & NormalWerte(0).Text & "."
        ElseIf NormalWerte.Count > 1 Then
            Txt &= " " & NormalText & " waren normal."
        End If

        Return Txt
    End Function

    Private Function JoinText(ByVal Source As List(Of GenderText)) As String
        Dim Result As String = ""
        Select Case Source.Count
            Case 0

            Case 1
                Result = Source(0).Text
            Case 2
                Result = Source(0).Text & " und " & Source(1).Text
            Case Else
                For I As Integer = 0 To Source.Count - 2
                    Result &= ", " & Source(I).Text
                Next
                Result = Result.Substring(2)
                Result = Result & " und " & Source(Source.Count - 1).Text
        End Select

        Return Result
    End Function

    Private Sub RefreshText()
        Dim TmpText As String = CreateText()
        If m_Text <> TmpText Then
            m_Text = TmpText
            RaiseEvent TextChanged()
        End If
    End Sub

End Class
